// SAX.cpp

#include "stdafx.h"
#include "SAX.h"

namespace Xml
{
	HRESULT ReadXmlFromFile(
		LPCWSTR filename,
		ISAXContentHandler*	pContextHandler,
		ISAXErrorHandler*	pErrorHandler,
		ISAXDTDHandler*		pDTDHandler)
	{
		HRESULT hr;
		ISAXXMLReaderPtr pReader;
		hr = pReader.CreateInstance(__uuidof(SAXXMLReader));
		if FAILED(hr)
			return hr;
		if(pContextHandler)
			pReader->putContentHandler(pContextHandler);
		if(pErrorHandler)
			pReader->putErrorHandler(pErrorHandler);
		if(pDTDHandler)
			pReader->putDTDHandler(pDTDHandler);
		hr = pReader->parseURL(const_cast<LPWSTR>(filename));
		return hr;
	}

	HRESULT ReadXmlFromStream(
		VARIANT src,
		ISAXContentHandler*	pContextHandler,
		ISAXErrorHandler*	pErrorHandler,
		ISAXDTDHandler*		pDTDHandler)
	{
		HRESULT hr;
		ISAXXMLReaderPtr pReader;
		hr = pReader.CreateInstance(__uuidof(SAXXMLReader));
		if FAILED(hr)
			return hr;
		if(pContextHandler)
			pReader->putContentHandler(pContextHandler);
		if(pErrorHandler)
			pReader->putErrorHandler(pErrorHandler);
		if(pDTDHandler)
			pReader->putDTDHandler(pDTDHandler);
		hr = pReader->parse(src);
		return hr;
	}
}
