// SAX.h
#pragma once

#import <msxml3.dll> raw_interfaces_only 

namespace Xml
{
	using namespace MSXML2;

	/// XMLt@Cw肵ASAXgpĉ͂
	/// @param src [i] XML\[X. VT_BSTR, SafeArray of bytes(VT_ARRAYVT_UI1), IStream, ISequentialStream w\.
	HRESULT ReadXmlFromFile(
		LPCWSTR filename,
		ISAXContentHandler*	pContextHandler,
		ISAXErrorHandler*	pErrorHandler = NULL,
		ISAXDTDHandler*		pDTDHandler = NULL);

	/// XMLXg[w肵ASAXgpĉ͂
	/// @param src [i] XML\[X. VT_BSTR, SafeArray of bytes(VT_ARRAYVT_UI1), IStream, ISequentialStream w\.
	HRESULT ReadXmlFromStream(
		VARIANT src,
		ISAXContentHandler*	pContextHandler,
		ISAXErrorHandler*	pErrorHandler = NULL,
		ISAXDTDHandler*		pDTDHandler = NULL);

	// SAXContentHandler
	class SAXContentHandler : public ISAXContentHandler
	{
	public:
		STDMETHODIMP_(ULONG) AddRef()	{ return 1; }
		STDMETHODIMP_(ULONG) Release()	{ return 1; }
		STDMETHODIMP QueryInterface(REFIID iid, void** ppObj)
		{
			if(iid == __uuidof(ISAXContentHandler) || iid == __uuidof(IUnknown))
			{
				*ppObj = this;
				AddRef();
				return S_OK;
			}
			*ppObj = NULL;
			return E_NOINTERFACE;
		}

		STDMETHODIMP putDocumentLocator( 
			ISAXLocator* pLocator)
		{ return S_OK; }
			
		STDMETHODIMP startDocument()
		{ return S_OK; }
		
		STDMETHODIMP endDocument()
		{ return S_OK; }

		STDMETHODIMP startPrefixMapping( 
			LPWSTR pwchPrefix,	int cchPrefix,
			LPWSTR pwchUri,	int cchUri)
		{ return S_OK; }

		STDMETHODIMP endPrefixMapping( 
			LPWSTR pwchPrefix,	int cchPrefix)
		{ return S_OK; }
		
		STDMETHODIMP startElement( 
			LPWSTR pwchNamespaceUri,	int cchNamespaceUri,
			LPWSTR pwchLocalName,		int cchLocalName,
			LPWSTR pwchRawName,			int cchRawName,
			ISAXAttributes* pAttributes)
		{ return S_OK; }
		
		STDMETHODIMP endElement( 
			LPWSTR pwchNamespaceUri,	int cchNamespaceUri,
			LPWSTR pwchLocalName,		int cchLocalName,
			LPWSTR pwchRawName,			int cchRawName)
		{ return S_OK; }

		STDMETHODIMP characters( 
			LPWSTR pwchChars,	int cchChars)
		{ return S_OK; }
		
		STDMETHODIMP ignorableWhitespace( 
			LPWSTR pwchChars,	int cchChars)
		{ return S_OK; }
		
		STDMETHODIMP processingInstruction( 
			LPWSTR pwchTarget,	int cchTarget,
			LPWSTR pwchData,	int cchData)
		{ return S_OK; }
		
		STDMETHODIMP skippedEntity( 
			LPWSTR pwchName,	int cchName)
		{ return S_OK; }
	};

	// SAXErrorHandler
	class SAXErrorHandler : public ISAXErrorHandler
	{
	public:
		STDMETHODIMP_(ULONG) AddRef()	{ return 1; }
		STDMETHODIMP_(ULONG) Release()	{ return 1; }
		STDMETHODIMP QueryInterface(REFIID iid, void** ppObj)
		{
			if(iid == __uuidof(ISAXContentHandler) || iid == __uuidof(IUnknown))
			{
				*ppObj = this;
				AddRef();
				return S_OK;
			}
			*ppObj = NULL;
			return E_NOINTERFACE;
		}

		STDMETHODIMP error( 
			ISAXLocator* pLocator,
			unsigned short * pwchErrorMessage,
			HRESULT errCode)
		{ return S_OK; }

		STDMETHODIMP fatalError( 
			ISAXLocator* pLocator,
			unsigned short * pwchErrorMessage,
			HRESULT errCode)
		{ return S_OK; }
		
		STDMETHODIMP ignorableWarning( 
			ISAXLocator* pLocator,
			unsigned short * pwchErrorMessage,
			HRESULT errCode)
		{ return S_OK; }
	};

	// SAXDTDHandler
	class SAXDTDHandler : public ISAXDTDHandler
	{
	public:
		STDMETHODIMP_(ULONG) AddRef()	{ return 1; }
		STDMETHODIMP_(ULONG) Release()	{ return 1; }
		STDMETHODIMP QueryInterface(REFIID iid, void** ppObj)
		{
			if(iid == __uuidof(ISAXContentHandler) || iid == __uuidof(IUnknown))
			{
				*ppObj = this;
				AddRef();
				return S_OK;
			}
			*ppObj = NULL;
			return E_NOINTERFACE;
		}

		STDMETHODIMP notationDecl( 
			LPWSTR pwchName,		int cchName,
			LPWSTR pwchPublicId,	int cchPublicId,
			LPWSTR pwchSystemId,	int cchSystemId)
		{ return S_OK; }
			
		STDMETHODIMP unparsedEntityDecl( 
			LPWSTR pwchName,			int cchName,
			LPWSTR pwchPublicId,		int cchPublicId,
			LPWSTR pwchSystemId,		int cchSystemId,
			LPWSTR pwchNotationName,	int cchNotationName)
		{ return S_OK; }
	};
}
