// main.cpp

#include "stdafx.h"
#include "XmlResource.h"
#include "resource.h"
#include <algorithm>
#define MAX_LOADSTRING 100

// O[oϐ :
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX

// ̃R[h W[Ɋ܂܂֐̐錾]܂ :
ATOM				MyRegisterClass(HINSTANCE hInstance);
HWND				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

////////////////////////////////////////////////////////////////////////////////
//

enum CMD
{
	CMD_Null,		// 0 ͎gȂƁB
	CMD_AppExit,
	CMD_AppAbout,
};

// R}hƃG[nh
class LoadResourceHandler : public Xml::ILoadResourceHandler
{
public:
	struct Command
	{
		LPCWSTR	name;
		UINT	id;

		friend operator < (const Command& lhs, const LPCWSTR& rhs)
		{
			return wcscmp(lhs.name, rhs) < 0;
		}
	};

	UINT NameToID(LPCWSTR name)
	{
		// nameŃ\[gς݂ł邱ƁB
		const Command SYSTEM_COMMAND[] = 
		{
			L"AppAbout"			, CMD_AppAbout,
			L"AppExit"			, CMD_AppExit,
		};

		const Command* beg	= SYSTEM_COMMAND;
		const Command* end	= SYSTEM_COMMAND + sizeof(SYSTEM_COMMAND) / sizeof(SYSTEM_COMMAND[0]);
		const Command* found = std::lower_bound(beg, end, name);
		if(found != end && wcscmp(found->name, name) == 0)
			return found->id;
		else
			return 0;
	}
	void	OnError(LPCTSTR message)
	{
		// {́AReiɒǉĂAŌɕ\ق悢
		MessageBox(NULL, message, NULL, MB_OK | MB_ICONERROR);
	}
	void	OnWarning(LPCTSTR message)
	{
		// {́AReiɒǉĂAŌɕ\ق悢
		MessageBox(NULL, message, NULL, MB_OK | MB_ICONWARNING);
	}
};

//
////////////////////////////////////////////////////////////////////////////////

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: ɃR[h}ĂB
	MSG msg;
	HWND	hWnd;
	HACCEL	hAccelTable;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MSXMLRESOURCE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂B:
	if ((hWnd = InitInstance (hInstance, nCmdShow)) == NULL) 
	{
		return FALSE;
	}

	////////////////////////////////////////////////////////////////////////////////
	//

	CoInitialize(NULL);	// MSXMLCOMIuWFNg
	LoadResourceHandler handler;
	SetMenu(hWnd, Xml::LoadMenuFromFile(_T("../xml/menu.xml"), &handler));
	hAccelTable = Xml::LoadAcceleratorsFromFile(_T("../xml/accelerators.xml"), &handler);
	CoUninitialize();

	//
	////////////////////////////////////////////////////////////////////////////////

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   
   // C bZ[W [v :
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg :
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//     Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ 
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_MSXMLRESOURCE);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   ֐ : InitInstance(HANDLE, int)
//
//   ړI : CX^X nhۑāAC EBhE쐬܂B
//
//   Rg :
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
HWND InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return NULL;
   }

   return hWnd;
}

//
//  ֐ : WndProc(HWND, unsigned, WORD, LONG)
//
//  ړI :  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Iꂽj[̉ :
		switch (wmId)
		{
		case CMD_AppAbout:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case CMD_AppExit:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
